# Timbuk web toplevel

This is a web interface for the Timbuk library in an OCaml toplevel using js_of_ocaml.

## Installation

### Dependencies

Building an js_of_ocaml toplevel requires a lot of dependencies (appart from Timbuk itself).
We strongly recommand the use of [OPAM](http://opam.ocaml.org/),
it will make your life easier.

#### Timbuk3

To install Timbuk, follow the instruction at http://people.irisa.fr/Thomas.Genet/timbuk

#### Js_of_ocaml

  - js_of_ocaml (2.6)
  - ocaml-migrate-parsetree
  - ppx_tools_versioned

You can install these dependency with OPAM using the command:

    opam install js_of_ocaml ocaml-migrate-parsetree ppx_tools_versioned

#### Other

  - tyxml
  - reactiveData
  - ocp-indent: to support indentation in the toplevel
  - higlo: to support syntax highlighting in the toplevel

You can install these dependencies with OPAM using the command:

    opam install tyxml reactiveData ocp-indent higlo

### Commands

    ./configure
    make

### Advanced options

The `./configure` scripts comes with an option to change the path of the Timbuk library.
By default, it will try to find in `/usr/local/lib/timbuk/timbuk.cma`,
which is the default installation path of Timbuk.
However you can specify a diferent path using:

  ./configure --timbuk /path/to/timbuk.cma

## Usage

Since this interface does not use any server-side program,
you can directly use it just by through a web browser with the URL
`file://[path_to_the_root_folder]/index.html`.
